## -*- coding: utf-8 -*-

from Scripts.dependencies_setup import dependencies_install, dependencies_remove
from Scripts.skins_setup import skins_install, skins_remove
from Scripts.language_setup import language_install, language_remove
from Scripts.kupu_setup import kupu_install, kupu_remove
from Scripts.mailhost_setup import mailhost_install, mailhost_remove
from Scripts.security_setup import security_install, security_remove
from Scripts.actions_setup import actions_install, actions_remove
from Scripts.types_setup import types_install, types_remove
from Scripts.factory_setup import factory_install, factory_remove
from Scripts.workflows_setup import workflows_install, workflows_remove
from Scripts.objects_setup import objects_install, objects_remove
from Scripts.placeful_workflows_setup import placeful_workflows_install, placeful_workflows_remove
from Scripts.members_setup import members_install, members_remove
from Scripts.external_methods_setup import external_methods_install, external_methods_remove
from Scripts.tools_setup import tools_install, tools_remove
from AdvancedLogger import AdvancedLogger



def InstallProduct(self, out, project_name, globals):
  logOutput = AdvancedLogger()

  dependencies_install(self, logOutput, project_name, globals)
  skins_install(self, logOutput, project_name, globals)
  language_install(self, logOutput, project_name, globals)
  kupu_install(self, logOutput, project_name, globals)
  mailhost_install(self, logOutput, project_name, globals)
  security_install(self, logOutput, project_name, globals)
  actions_install(self, logOutput, project_name, globals)
  types_install(self, logOutput, project_name, globals)
  factory_install(self, logOutput, project_name, globals)
  workflows_install(self, logOutput, project_name, globals)
  objects_install(self, logOutput, project_name, globals)
  placeful_workflows_install(self, logOutput, project_name, globals)
  members_install(self, logOutput, project_name, globals)
  external_methods_install(self, logOutput, project_name, globals)
  tools_install(self, logOutput, project_name, globals)

  print >> out, logOutput.getvalue()



def RemoveProduct(self, out, project_name, globals):
  logOutput = AdvancedLogger()

  tools_remove(self, logOutput, project_name, globals)
  external_methods_remove(self, logOutput, project_name, globals)
  members_remove(self, logOutput, project_name, globals)
  placeful_workflows_remove(self, logOutput, project_name, globals)
  objects_remove(self, logOutput, project_name, globals)
  workflows_remove(self, logOutput, project_name, globals)
  factory_remove(self, logOutput, project_name, globals)
  types_remove(self, logOutput, project_name, globals)
  actions_remove(self, logOutput, project_name, globals)
  security_remove(self, logOutput, project_name, globals)
  mailhost_remove(self, logOutput, project_name, globals)
  kupu_remove(self, logOutput, project_name, globals)
  language_remove(self, logOutput, project_name, globals)
  skins_remove(self, logOutput, project_name, globals)
  dependencies_remove(self, logOutput, project_name, globals)

  print >> out, logOutput.getvalue()



