###########################################################################################################
## Permissions pour les états "publiés"
###########################################################################################################
## Permissions pour la publication sur internet.
## Tout le monde peut lire le document, même les utilisateur anonymes (non identifiés).
#### Principalement utile pour la page d'accueil ;)
published_permissions = (
          { 'permission' : 'Access contents information', 'acquired' : 0, 'roles' : ['Anonymous', 'Manager'], },
          { 'permission' : 'Modify portal content', 'acquired' : 0, 'roles' : ['Manager'], },
          { 'permission' : 'View', 'acquired' : 0, 'roles' : ['Anonymous', 'Manager'], },
          { 'permission' : 'Change portal events', 'acquired' : 0, 'roles' : ['Manager'], },
          { 'permission' : 'Request review', 'acquired' : 1, 'roles' : ['Owner', 'Member',], },
          { 'permission' : 'Review portal content', 'acquired' : 1, 'roles' : ['Owner', 'Member',], },

          { 'permission' : 'Manage properties', 'acquired' : 0, 'roles' : ['Manager'],},
          { 'permission' : 'Undo changes', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'Add portal events', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'Change local roles', 'acquired' : 0, 'roles' : ['Manager', 'Reviewer'],},
          { 'permission' : 'Change portal topics', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'Edit PlonePopoll', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'Modify constrain types', 'acquired' : 0, 'roles' : ['Manager'],},
          { 'permission' : 'Modify view template', 'acquired' : 0, 'roles' : ['Manager', 'Reviewer'],},
          { 'permission' : 'Set Group Ownership', 'acquired' : 0, 'roles' : ['Manager'],},
          { 'permission' : 'View Groups', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'WebDAV Lock items', 'acquired' : 0, 'roles' : [],},
          { 'permission' : 'WebDAV Unlock items', 'acquired' : 0, 'roles' : [],},
          { 'permission' : 'WebDAV access', 'acquired' : 0, 'roles' : [],},
        )

###########################################################################################################
## Permissions pour le workflow partant de l'état "privé".
###########################################################################################################
## Permissions pour l'édition privée de documents
private_permissions = (
          { 'permission' : 'Access contents information', 'acquired' : 0, 'roles' : ['Manager', 'Member', 'Owner'], },
          { 'permission' : 'Modify portal content', 'acquired' : 0, 'roles' : ['Manager', 'Member', 'Owner'], },
          { 'permission' : 'View', 'acquired' : 0, 'roles' : ['Manager', 'Member', 'Owner'], },
          { 'permission' : 'Change portal events', 'acquired' : 0, 'roles' : ['Manager', 'Member', 'Owner'], },
          { 'permission' : 'Request review', 'acquired' : 1, 'roles' : ['Owner', 'Member',], },
          { 'permission' : 'Review portal content', 'acquired' : 1, 'roles' : ['Owner', 'Member',], },

          { 'permission' : 'Manage properties', 'acquired' : 0, 'roles' : ['Manager'],},
          { 'permission' : 'Undo changes', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'Add portal events', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'Change local roles', 'acquired' : 0, 'roles' : ['Manager', 'Reviewer'],},
          { 'permission' : 'Change portal topics', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'Edit PlonePopoll', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'Modify constrain types', 'acquired' : 0, 'roles' : ['Manager'],},
          { 'permission' : 'Modify view template', 'acquired' : 0, 'roles' : ['Manager', 'Reviewer', 'Member'],},
          { 'permission' : 'Set Group Ownership', 'acquired' : 0, 'roles' : ['Manager'],},
          { 'permission' : 'View Groups', 'acquired' : 1, 'roles' : [],},
          { 'permission' : 'WebDAV Lock items', 'acquired' : 0, 'roles' : [],},
          { 'permission' : 'WebDAV Unlock items', 'acquired' : 0, 'roles' : [],},
          { 'permission' : 'WebDAV access', 'acquired' : 0, 'roles' : [],},
        )


###########################################################################################################
## Description du workflow.
###########################################################################################################

workflow_associated_types = '__default__'

workflow_definition = {
    'title' : 'Simple site Workflow',
    'initial_state' : 'private',
    'state_variable' : 'review_state',
    'managedPermissions' : (
      'Access contents information',
      'Modify portal content',
      'View',
      'Change portal events',
      'Request review',
      'Review portal content',

      'Manage properties',
      'Undo changes',
      'Add portal events',
      'Change local roles',
      'Change portal topics',
      'Edit PlonePopoll',
      'Modify constrain types',
      'Modify view template',
      'Set Group Ownership',
      'View Groups',
      'WebDAV Lock items',
      'WebDAV Unlock items',
      'WebDAV access',
    ),
    'states' : {

      # Etat privé
      'private' : {
        'title' : 'Private',
        'transitions' : ('publish',),
        'permissions' : private_permissions,
      },

      'published' : {
        'title' : 'Published',
        'transitions' : ('hide'),
        'permissions' : published_permissions,
      },

    },
    'transitions' : {
      'hide' : {
        'title' : """Member makes content private""",
        'new_state_id' : """private""",
        'trigger_type' : 1,
        'script_name' : """""",
        'after_script_name' : """""",
        'actbox_name' : """Make private""",
        'actbox_url' : """%(content_url)s/content_hide_form""",
        'actbox_category' : """workflow""",
        'props' : {'guard_roles': 'Owner, Member',},
      },

      'publish' : {
        'title' : """Reviewer publishes content""",
        'new_state_id' : """published""",
        'trigger_type' : 1,
        'script_name' : """""",
        'after_script_name' : """""",
        'actbox_name' : """Publish""",
        'actbox_url' : """%(content_url)s/content_publish_form""",
        'actbox_category' : """workflow""",
        'props' : {'guard_permissions': 'Review portal content'},
      },

    },

    ## Variables : ne pas toucher, ca ne change pas en fonction du workflow.
    'variables' : {
      'action' : {
        'description' : """The last transition""",
        'default_value' : """""",
        'default_expr' : """transition/getId|nothing""",
        'for_catalog' : 0,
        'for_status' : 1,
        'update_always' : 1,
        'props' : None
      },
      'review_history' : {
        'description' : """Provides access to workflow history""",
        'default_value' : """""",
        'default_expr' : """state_change/getHistory""",
        'for_catalog' : 0,
        'for_status' : 0,
        'update_always' : 0,
        'props' : {'guard_permissions': 'Request review; Review portal content'}
      },
      'actor' : {
        'description' : """The ID of the user who performed the last transition""",
        'default_value' : """""",
        'default_expr' : """user/getId""",
        'for_catalog' : 0,
        'for_status' : 1,
        'update_always' : 1,
        'props' : None
      },
      'comments' : {
        'description' : """Comments about the last transition""",
        'default_value' : """""",
        'default_expr' : """python:state_change.kwargs.get('comment', '')""",
        'for_catalog' : 0,
        'for_status' : 1,
        'update_always' : 1,
        'props' : None
      },
      'time' : {
        'description' : """Time of the last transition""",
        'default_value' : """""",
        'default_expr' : """state_change/getDateTime""",
        'for_catalog' : 0,
        'for_status' : 1,
        'update_always' : 1,
        'props' : None
      },
    },
    'worklists' : {
    },
    'scripts' : {
    },
  }



